
transmon = beamPath;
transmon.seedWaist(3.1e-3, -1.1);
targetRayleigh = 0.15;
transmon.targetWaist(sqrt(targetRayleigh*1.064e-6/pi), 0.5);


f1 = 343e-3;    % CVI fused silica
f2 = -114e-3;   % CVI fused silica
f1 = 333e-3;    % r = 150 mm fused silica
f2 =-111e-3;    % r = -50 mm fused silica

transmon.addComponent(...
        component.lens(f1, 0, 'L1'));
transmon.addComponent(...
        component.lens(f2, 246e-3, 'L2'));
%% optimize


transmon = transmon.optimizePath('L2', [0.01 0.5], ...
    'target', [0.01 2]);

transmon.addComponent(...
        component.flatMirror(transmon.targetz-targetRayleigh, 'QPD1'));
transmon.addComponent(...
        component.flatMirror(transmon.targetz+targetRayleigh, 'QPD2'));
    
zz = linspace(-0.5, 1.5, 1000);

clf;
display(transmon.components);

transmon.plotSummary(zz);
ylim([-10 180]);
shg
saveas(1, 'TRANSMON_beampath.pdf', 'pdf');
