


mirror = @(R) [1 0; -2/R 1];
mLength = @(tL) [1 tL; 0 1];

% par = [R1 R2 R3 L1 L2];
myTel = @(par) mirror(par(3)) * mLength(par(5)) * mirror(par(2)) * mLength(par(4)) * mirror(par(1));
afterm1 = @(par) mirror(par(1));
beforem2 = @(par) mLength(par(4)) * mirror(par(1));
afterm2 = @(par) mirror(par(2)) *  mLength(par(4)) * mirror(par(1));
beforem3 = @(par) mLength(par(5)) * mirror(par(2)) *  mLength(par(4)) * mirror(par(1));

newQ = @(q, ABCD) (ABCD(1,1)*q + ABCD(1,2))/(ABCD(2,1)*q + ABCD(2,2));

q_in = 1.03+13.1i;
q_out = pi*1.7e-3^2/1.064e-6 *1i;              % This gives a  2 mm waist

g1 = @(par) 180/pi*(angle(newQ(q_in, beforem2(par))) - angle(newQ(q_in, afterm1(par))));
g2 = @(par) 180/pi*(angle(newQ(q_in, beforem3(par))) - angle(newQ(q_in, afterm2(par)))) + g1(par);
 


m1 = [1.5:0.1:3.0 inf ];
m2 = [-2:0.1:-.3 inf];
m3 = [1.5:0.1:2.5 inf];
m1 = 1.7;
m3 = 1.7;

mirr = [-2:0.2:-0.5 0.5:0.2:3];


result = [];
for ii = 1:length(m1)
    for jj = 1:length(m2)
        for kk = 1:length(m3)
    
            guess = [1 1];
            myFunc = @(x) abs(newQ(q_in, myTel([m1(ii) m2(jj) m3(kk) x])) - q_out);

            [xout, fval] = fminsearch(myFunc, guess);
            param = [m1(ii) m2(jj) m3(kk) xout];
            if(all(xout > 0.1) & all(xout < 1.7) & all(isfinite(xout)) & isfinite(fval) )
                
                
                
                %% length sensitivity
                % move L1
                dg1_1 =  g1(param + [0 0 0 param(4)*0.01 0]);
                dg1 =  dg1_1 - g1(param - [0 0 0 param(4)*0.01 0]);
                
                % move L2
                dg2_1 =   g2(param + [0 0 0 0 param(5)*0.01 ]);
                dg2 =  dg2_1 - g2(param - [0 0 0 0 param(5)*0.01]);
                
                dgdl = max(abs(dg1), abs(dg2));

                for mm = 1:3
                    t = zeros(1,5);
                    t(mm) = 1;
                    dg1 = g1(param + param(mm)*0.01*t);
                    dg1 = dg1 - g1(param - param(mm)*0.01*t);
                    dg2 = g2(param + param(mm)*0.01*t);
                    dg2 = dg2 - g2(param - param(mm)*0.01*t);
                    dm(mm) = max(abs(dg1), abs(dg2));
                end
                
                result(end+1,:) = ...
                    [m1(ii) m2(jj) m3(kk) xout(1) xout(2) g1(param) g2(param) g2(param)-g1(param) dgdl max(dm)];

            end
        end
    end
end
idx = find( (abs(mod(result(:,6),180)-90)<30 | abs(mod(result(:,7),180)-90)<30 | abs(mod(result(:,8),180)-90)<30) & any(abs(result(:,1:3)- 1.7)<0.01,2));
[t, iii] = sort(result(idx,end));
result(idx(iii),:)


%% actual answer
if 1

%    R = [2.5 -0.6 1.7];
%    L = [1.35 0.91];
    R = [1.7 -0.6 1.7];
    L = [0.833 0.853];

    
    refl = beamPath;
    qin = beamq;
    qin.q =  1.03+13.1i;
    refl.seedq = qin;
    refl.seedz = 0;
    w_target = 350e-6;
    
    refl.targetWaist(w_target, sum(L)+3);
    
    xout = fminsearch(myFunc, guess);

    refl.addComponent(...
        component.curvedMirror(R(1), 0+1e-6, 'R1'));
    refl.addComponent(...
        component.curvedMirror(R(2), L(1),'R2'));
    refl.addComponent(...
        component.curvedMirror(R(3), sum(L),'R3'));
    refl.addComponent(...
        component.lens(0.343, sum(L)+1, 'L1'));
    refl.addComponent(...
        component.lens(-0.229, sum(L)+1.2, 'L2'));
    
    refl = refl.optimizePath('L2', [sum(L)+1 sum(L)+2], ...
            'target', [sum(L)+1.1 sum(L)+3]);
        
    
    z_target = pi*w_target^2/1.064e-6;
    refl.addComponent(...
        component.flatMirror(refl.targetz-z_target, 'QPD1'));
    refl.addComponent(...
        component.flatMirror(refl.targetz+z_target, 'QPD2'));
       

%refl.components
zz = -.5:1e-2:5;
refl.plotSummary(zz)
shg
end
