q_in = 1.35+20.8i;

ABCD = @(x, r1, r2) [1 0; -2/r2 1] * [ 1 x; 0 1] * [1 0; -2/r1 1];
newQ = @(q, ABCD) (q*ABCD(1,1) + ABCD(1,2)) / (q*ABCD(2,1) + ABCD(2,2));
minFunc = @(x) abs(real(newQ(q_in, ABCD(x, 0.5, 0.5))));

realfunc = @(q, ABCD) ABCD(1,1)*ABCD(2,1)*q*conj(q) + ...
    ABCD(1,2)*ABCD(2,2) + ABCD(1,2)*ABCD(2,1)*real(q) + ...
    ABCD(1,1)*ABCD(2,2)*real(q);
twoFunc = @(x) abs(realfunc(q_in, ABCD(x, 0.5, 0.5)));

opts = optimset('MaxFunEvals', 1e7, 'TolX', 1e-5,   'TolFun',  1e-7);
xout = fminsearch(twoFunc, 0.50, opts)

newQ(q_in, ABCD(xout, 0.5, 0.5))
