function g = TweenGouy(x, r, q0)
% Calculates the Gouy phase through a telescope starting at q0 and going a
% distance x then mirror r

gPhase = 0;
for ii = 1:length(x)
    ABCD = [1 x(ii); 0 1];
    q1 = newQ(q0,ABCD);
    gPhase = angle(q1)-angle(q0) + gPhase;
    
    ABCD = [1 0; -2/r(ii) 1];
    q0 = newQ(q1, ABCD);
    
end

g = gPhase * 180 /  pi;
