%% magic gouy telescope

um = 1e-6;
mm = 1e-3;
cm = 1e-2;
lambda = 1.064 * um;

w_seed = 350 * um;
w_target = 3.3 * mm;
xoffset = 10 * cm;
zRayleigh = pi * w_seed^2/lambda;

radii = [-2 -1 inf 1 2];
mirrorList = component.curvedMirror(radii,0,'M1');

% set up a path

pop = beamPath;
pop.seedWaist(w_seed, 0);
pop.targetWaist(w_target, 3);
pop.addComponent(component.curvedMirror(0,zRayleigh + 0.1, 'M1'));
pop.addComponent(component.curvedMirror(0,zRayleigh + 1.1, 'M2'));
pop.addComponent(component.curvedMirror(0,zRayleigh + 2.1, 'M3'));


x_offset = [10:10:100] * cm;


%data = [];
for ii = 2:length(x_offset)
    z1 = zRayleigh+x_offset(ii);
    [pathlist overlap] = ...
        pop.chooseComponents('M1', mirrorList.duplicate, [1 1]*z1, ...
        'M2', mirrorList.duplicate, z1+[0.1 1], ...
        'M3', mirrorList.duplicate, z1+[0.2 2], ...
        'target', z1+[0.3 3], ...
        '-v');
    idx = find(overlap > 0.99);
    pathlist = pathlist(idx);
    
    for jj = 1:length(idx)
        dl = length(data)+1;
        data(dl).offset = x_offset(ii);
        data(dl).minSpacing = ...
            min(pathlist(jj).component('M3').z - pathlist(jj).component('M2').z, ...
                pathlist(jj).component('M2').z - pathlist(jj).component('M1').z);
        data(dl).maxSpacing = ...
            max(pathlist(jj).component('M3').z - pathlist(jj).component('M2').z, ...
                pathlist(jj).component('M2').z - pathlist(jj).component('M1').z);
        data(dl).gouyPhase = pathlist(jj).gouyPhase(pathlist(jj).component('M3').z);
        data(dl).path = pathlist(jj);
    end
    
end
